/*
 * java-gnome, a UI library for writing GTK and GNOME programs from Java!
 *
 * Copyright ? 2006-2011 Operational Dynamics Consulting, Pty Ltd and Others
 *
 * The code in this file, and the program it is a part of, is made available
 * to you by its authors as open source software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version
 * 2 ("GPL") as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GPL for more details.
 *
 * You should have received a copy of the GPL along with this program. If not,
 * see http://www.gnu.org/licenses/. The authors of this program may be
 * contacted through http://java-gnome.sourceforge.net/.
 *
 * Linking this library statically or dynamically with other modules is making
 * a combined work based on this library. Thus, the terms and conditions of
 * the GPL cover the whole combination. As a special exception (the
 * "Claspath Exception"), the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your
 * choice, provided that you also meet, for each linked independent module,
 * the terms and conditions of the license of that module. An independent
 * module is a module which is not derived from or based on this library. If
 * you modify this library, you may extend the Classpath Exception to your
 * version of the library, but you are not obligated to do so. If you do not
 * wish to do so, delete this exception statement from your version.
 */

/*
 * THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_atk_AtkEditableText.h"

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1set_1text_1contents
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _string
)
{
	AtkEditableText* self;
	const gchar* string;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter string
	string = (const gchar*) bindings_java_getString(env, _string);
	if (string == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	atk_editable_text_set_text_contents(self, string);

	// cleanup parameter self

	// cleanup parameter string
	bindings_java_releaseString(string);
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1insert_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _string,
	jint _length,
	jintArray _position
)
{
	AtkEditableText* self;
	const gchar* string;
	gint length;
	gint* position;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter string
	string = (const gchar*) bindings_java_getString(env, _string);
	if (string == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter length
	length = (gint) _length;

	// convert parameter position
	position = (gint*) (*env)->GetIntArrayElements(env, _position, NULL);
	if (position == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	atk_editable_text_insert_text(self, string, length, position);

	// cleanup parameter self

	// cleanup parameter string
	bindings_java_releaseString(string);

	// cleanup parameter length

	// cleanup parameter position
	(*env)->ReleaseIntArrayElements(env, _position, (jint*)position, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1copy_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startPos,
	jint _endPos
)
{
	AtkEditableText* self;
	gint startPos;
	gint endPos;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter startPos
	startPos = (gint) _startPos;

	// convert parameter endPos
	endPos = (gint) _endPos;

	// call function
	atk_editable_text_copy_text(self, startPos, endPos);

	// cleanup parameter self

	// cleanup parameter startPos

	// cleanup parameter endPos
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1cut_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startPos,
	jint _endPos
)
{
	AtkEditableText* self;
	gint startPos;
	gint endPos;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter startPos
	startPos = (gint) _startPos;

	// convert parameter endPos
	endPos = (gint) _endPos;

	// call function
	atk_editable_text_cut_text(self, startPos, endPos);

	// cleanup parameter self

	// cleanup parameter startPos

	// cleanup parameter endPos
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1delete_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startPos,
	jint _endPos
)
{
	AtkEditableText* self;
	gint startPos;
	gint endPos;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter startPos
	startPos = (gint) _startPos;

	// convert parameter endPos
	endPos = (gint) _endPos;

	// call function
	atk_editable_text_delete_text(self, startPos, endPos);

	// cleanup parameter self

	// cleanup parameter startPos

	// cleanup parameter endPos
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1paste_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _position
)
{
	AtkEditableText* self;
	gint position;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter position
	position = (gint) _position;

	// call function
	atk_editable_text_paste_text(self, position);

	// cleanup parameter self

	// cleanup parameter position
}
