/*
 * java-gnome, a UI library for writing GTK and GNOME programs from Java!
 *
 * Copyright ? 2006-2011 Operational Dynamics Consulting, Pty Ltd and Others
 *
 * The code in this file, and the program it is a part of, is made available
 * to you by its authors as open source software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version
 * 2 ("GPL") as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GPL for more details.
 *
 * You should have received a copy of the GPL along with this program. If not,
 * see http://www.gnu.org/licenses/. The authors of this program may be
 * contacted through http://java-gnome.sourceforge.net/.
 *
 * Linking this library statically or dynamically with other modules is making
 * a combined work based on this library. Thus, the terms and conditions of
 * the GPL cover the whole combination. As a special exception (the
 * "Claspath Exception"), the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your
 * choice, provided that you also meet, for each linked independent module,
 * the terms and conditions of the license of that module. An independent
 * module is a module which is not derived from or based on this library. If
 * you modify this library, you may extend the Classpath Exception to your
 * version of the library, but you are not obligated to do so. If you do not
 * wish to do so, delete this exception statement from your version.
 */

/*
 * THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkWindow.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _parent,
	jlong _attributes,
	jint _attributesMask
)
{
	GdkWindow* result;
	jlong _result;
	GdkWindow* parent;
	GdkWindowAttr* attributes;
	gint attributesMask;

	// convert parameter parent
	parent = (GdkWindow*) _parent;

	// convert parameter attributes
	attributes = (GdkWindowAttr*) _attributes;

	// convert parameter attributesMask
	attributesMask = (gint) _attributesMask;

	// call function
	result = gdk_window_new(parent, attributes, attributesMask);

	// cleanup parameter parent

	// cleanup parameter attributes

	// cleanup parameter attributesMask

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1keep_1above
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GdkWindow* self;
	gboolean setting;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gdk_window_set_keep_above(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1keep_1below
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GdkWindow* self;
	gboolean setting;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gdk_window_set_keep_below(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1destroy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_destroy(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1window_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindowType result;
	jint _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_window_type(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1show
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_show(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1hide
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_hide(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1withdraw
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_withdraw(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1move
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y
)
{
	GdkWindow* self;
	gint x;
	gint y;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	gdk_window_move(self, x, y);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1resize
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width,
	jint _height
)
{
	GdkWindow* self;
	gint width;
	gint height;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// call function
	gdk_window_resize(self, width, height);

	// cleanup parameter self

	// cleanup parameter width

	// cleanup parameter height
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1move_1resize
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y,
	jint _width,
	jint _height
)
{
	GdkWindow* self;
	gint x;
	gint y;
	gint width;
	gint height;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// call function
	gdk_window_move_resize(self, x, y, width, height);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter width

	// cleanup parameter height
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1reparent
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _newParent,
	jint _x,
	jint _y
)
{
	GdkWindow* self;
	GdkWindow* newParent;
	gint x;
	gint y;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter newParent
	newParent = (GdkWindow*) _newParent;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	gdk_window_reparent(self, newParent, x, y);

	// cleanup parameter self

	// cleanup parameter newParent

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1raise
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_raise(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1lower
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_lower(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1focus
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _timestamp
)
{
	GdkWindow* self;
	guint32 timestamp;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter timestamp
	timestamp = (guint32) _timestamp;

	// call function
	gdk_window_focus(self, timestamp);

	// cleanup parameter self

	// cleanup parameter timestamp
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1override_1redirect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _overrideRedirect
)
{
	GdkWindow* self;
	gboolean overrideRedirect;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter overrideRedirect
	overrideRedirect = (gboolean) _overrideRedirect;

	// call function
	gdk_window_set_override_redirect(self, overrideRedirect);

	// cleanup parameter self

	// cleanup parameter overrideRedirect
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1scroll
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _dx,
	jint _dy
)
{
	GdkWindow* self;
	gint dx;
	gint dy;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter dx
	dx = (gint) _dx;

	// convert parameter dy
	dy = (gint) _dy;

	// call function
	gdk_window_scroll(self, dx, dy);

	// cleanup parameter self

	// cleanup parameter dx

	// cleanup parameter dy
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1child_1shapes
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_set_child_shapes(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1merge_1child_1shapes
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_merge_child_shapes(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1is_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_is_visible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1is_1viewable
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_is_viewable(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindowState result;
	jint _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_state(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1static_1gravities
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useStatic
)
{
	gboolean result;
	jboolean _result;
	GdkWindow* self;
	gboolean useStatic;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter useStatic
	useStatic = (gboolean) _useStatic;

	// call function
	result = gdk_window_set_static_gravities(self, useStatic);

	// cleanup parameter self

	// cleanup parameter useStatic

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1type_1hint
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _hint
)
{
	GdkWindow* self;
	GdkWindowTypeHint hint;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter hint
	hint = (GdkWindowTypeHint) _hint;

	// call function
	gdk_window_set_type_hint(self, hint);

	// cleanup parameter self

	// cleanup parameter hint
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1modal_1hint
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _modal
)
{
	GdkWindow* self;
	gboolean modal;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter modal
	modal = (gboolean) _modal;

	// call function
	gdk_window_set_modal_hint(self, modal);

	// cleanup parameter self

	// cleanup parameter modal
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1skip_1taskbar_1hint
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _modal
)
{
	GdkWindow* self;
	gboolean modal;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter modal
	modal = (gboolean) _modal;

	// call function
	gdk_window_set_skip_taskbar_hint(self, modal);

	// cleanup parameter self

	// cleanup parameter modal
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1skip_1pager_1hint
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _modal
)
{
	GdkWindow* self;
	gboolean modal;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter modal
	modal = (gboolean) _modal;

	// call function
	gdk_window_set_skip_pager_hint(self, modal);

	// cleanup parameter self

	// cleanup parameter modal
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1geometry_1hints
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _geometry,
	jint _flags
)
{
	GdkWindow* self;
	GdkGeometry* geometry;
	GdkWindowHints flags;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter geometry
	geometry = (GdkGeometry*) _geometry;

	// convert parameter flags
	flags = (GdkWindowHints) _flags;

	// call function
	gdk_window_set_geometry_hints(self, geometry, flags);

	// cleanup parameter self

	// cleanup parameter geometry

	// cleanup parameter flags
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1begin_1paint_1rect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rectangle
)
{
	GdkWindow* self;
	GdkRectangle* rectangle;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter rectangle
	rectangle = (GdkRectangle*) _rectangle;

	// call function
	gdk_window_begin_paint_rect(self, rectangle);

	// cleanup parameter self

	// cleanup parameter rectangle
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1end_1paint
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_end_paint(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _title
)
{
	GdkWindow* self;
	const gchar* title;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter title
	title = (const gchar*) bindings_java_getString(env, _title);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_window_set_title(self, title);

	// cleanup parameter self

	// cleanup parameter title
	bindings_java_releaseString(title);
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1role
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _role
)
{
	GdkWindow* self;
	const gchar* role;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter role
	role = (const gchar*) bindings_java_getString(env, _role);
	if (role == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_window_set_role(self, role);

	// cleanup parameter self

	// cleanup parameter role
	bindings_java_releaseString(role);
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1transient_1for
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _leader
)
{
	GdkWindow* self;
	GdkWindow* leader;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter leader
	leader = (GdkWindow*) _leader;

	// call function
	gdk_window_set_transient_for(self, leader);

	// cleanup parameter self

	// cleanup parameter leader
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1cursor
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _cursor
)
{
	GdkWindow* self;
	GdkCursor* cursor;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter cursor
	cursor = (GdkCursor*) _cursor;

	// call function
	gdk_window_set_cursor(self, cursor);

	// cleanup parameter self

	// cleanup parameter cursor
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1geometry
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y,
	jintArray _width,
	jintArray _height
)
{
	GdkWindow* self;
	gint* x;
	gint* y;
	gint* width;
	gint* height;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter width
	width = (gint*) (*env)->GetIntArrayElements(env, _width, NULL);
	if (width == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter height
	height = (gint*) (*env)->GetIntArrayElements(env, _height, NULL);
	if (height == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_window_get_geometry(self, x, y, width, height);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);

	// cleanup parameter width
	(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);

	// cleanup parameter height
	(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y
)
{
	GdkWindow* self;
	gint* x;
	gint* y;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_window_get_position(self, x, y);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1origin
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y
)
{
	gint result;
	jint _result;
	GdkWindow* self;
	gint* x;
	gint* y;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return  0; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return  0; // Java Exception already thrown
	}

	// call function
	result = gdk_window_get_origin(self, x, y);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1root_1origin
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y
)
{
	GdkWindow* self;
	gint* x;
	gint* y;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_window_get_root_origin(self, x, y);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1frame_1extents
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rect
)
{
	GdkWindow* self;
	GdkRectangle* rect;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter rect
	rect = (GdkRectangle*) _rect;

	// call function
	gdk_window_get_frame_extents(self, rect);

	// cleanup parameter self

	// cleanup parameter rect
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1pointer
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y,
	jintArray _mask
)
{
	GdkWindow* result;
	jlong _result;
	GdkWindow* self;
	gint* x;
	gint* y;
	GdkModifierType* mask;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter mask
	mask = (GdkModifierType*) (*env)->GetIntArrayElements(env, _mask, NULL);
	if (mask == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gdk_window_get_pointer(self, x, y, mask);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);

	// cleanup parameter mask
	(*env)->ReleaseIntArrayElements(env, _mask, (jint*)mask, 0);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1parent
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* result;
	jlong _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_parent(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1toplevel
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* result;
	jlong _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_toplevel(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1children
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GList* result;
	jlongArray _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_children(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// cleanup return value
	if (result != NULL) {
		g_list_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1peek_1children
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GList* result;
	jlongArray _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_peek_children(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1events
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkEventMask result;
	jint _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_events(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1events
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _eventMask
)
{
	GdkWindow* self;
	GdkEventMask eventMask;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter eventMask
	eventMask = (GdkEventMask) _eventMask;

	// call function
	gdk_window_set_events(self, eventMask);

	// cleanup parameter self

	// cleanup parameter eventMask
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1icon_1list
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _pixbufs
)
{
	GdkWindow* self;
	GList* pixbufs;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter pixbufs
	pixbufs = (GList*) bindings_java_convert_jarray_to_glist(env, _pixbufs);
	if (pixbufs == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_window_set_icon_list(self, pixbufs);

	// cleanup parameter self

	// cleanup parameter pixbufs
	g_list_free(pixbufs);
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	GdkWindow* self;
	const gchar* name;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter name
	name = (const gchar*) bindings_java_getString(env, _name);
	if (name == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_window_set_icon_name(self, name);

	// cleanup parameter self

	// cleanup parameter name
	bindings_java_releaseString(name);
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _leader
)
{
	GdkWindow* self;
	GdkWindow* leader;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter leader
	leader = (GdkWindow*) _leader;

	// call function
	gdk_window_set_group(self, leader);

	// cleanup parameter self

	// cleanup parameter leader
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* result;
	jlong _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_group(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1iconify
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_iconify(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1deiconify
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_deiconify(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1stick
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_stick(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1unstick
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_unstick(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1maximize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_maximize(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1unmaximize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_unmaximize(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1fullscreen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_fullscreen(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1unfullscreen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_unfullscreen(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1register_1dnd
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_register_dnd(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1begin_1resize_1drag
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _edge,
	jint _button,
	jint _rootX,
	jint _rootY,
	jint _timestamp
)
{
	GdkWindow* self;
	GdkWindowEdge edge;
	gint button;
	gint rootX;
	gint rootY;
	guint32 timestamp;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter edge
	edge = (GdkWindowEdge) _edge;

	// convert parameter button
	button = (gint) _button;

	// convert parameter rootX
	rootX = (gint) _rootX;

	// convert parameter rootY
	rootY = (gint) _rootY;

	// convert parameter timestamp
	timestamp = (guint32) _timestamp;

	// call function
	gdk_window_begin_resize_drag(self, edge, button, rootX, rootY, timestamp);

	// cleanup parameter self

	// cleanup parameter edge

	// cleanup parameter button

	// cleanup parameter rootX

	// cleanup parameter rootY

	// cleanup parameter timestamp
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1begin_1move_1drag
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _button,
	jint _rootX,
	jint _rootY,
	jint _timestamp
)
{
	GdkWindow* self;
	gint button;
	gint rootX;
	gint rootY;
	guint32 timestamp;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter button
	button = (gint) _button;

	// convert parameter rootX
	rootX = (gint) _rootX;

	// convert parameter rootY
	rootY = (gint) _rootY;

	// convert parameter timestamp
	timestamp = (guint32) _timestamp;

	// call function
	gdk_window_begin_move_drag(self, button, rootX, rootY, timestamp);

	// cleanup parameter self

	// cleanup parameter button

	// cleanup parameter rootX

	// cleanup parameter rootY

	// cleanup parameter timestamp
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1invalidate_1rect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rect,
	jboolean _invalidateChildren
)
{
	GdkWindow* self;
	GdkRectangle* rect;
	gboolean invalidateChildren;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter rect
	rect = (GdkRectangle*) _rect;

	// convert parameter invalidateChildren
	invalidateChildren = (gboolean) _invalidateChildren;

	// call function
	gdk_window_invalidate_rect(self, rect, invalidateChildren);

	// cleanup parameter self

	// cleanup parameter rect

	// cleanup parameter invalidateChildren
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1freeze_1updates
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_freeze_updates(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1thaw_1updates
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_thaw_updates(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1process_1updates
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _updateChildren
)
{
	GdkWindow* self;
	gboolean updateChildren;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter updateChildren
	updateChildren = (gboolean) _updateChildren;

	// call function
	gdk_window_process_updates(self, updateChildren);

	// cleanup parameter self

	// cleanup parameter updateChildren
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1accept_1focus
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _acceptFocus
)
{
	GdkWindow* self;
	gboolean acceptFocus;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter acceptFocus
	acceptFocus = (gboolean) _acceptFocus;

	// call function
	gdk_window_set_accept_focus(self, acceptFocus);

	// cleanup parameter self

	// cleanup parameter acceptFocus
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1focus_1on_1map
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _focusOnMap
)
{
	GdkWindow* self;
	gboolean focusOnMap;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter focusOnMap
	focusOnMap = (gboolean) _focusOnMap;

	// call function
	gdk_window_set_focus_on_map(self, focusOnMap);

	// cleanup parameter self

	// cleanup parameter focusOnMap
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1enable_1synchronized_1configure
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_enable_synchronized_configure(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1configure_1finished
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_configure_finished(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1urgency_1hint
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _urgent
)
{
	GdkWindow* self;
	gboolean urgent;

	// convert parameter self
	self = (GdkWindow*) _self;

	// convert parameter urgent
	urgent = (gboolean) _urgent;

	// call function
	gdk_window_set_urgency_hint(self, urgent);

	// cleanup parameter self

	// cleanup parameter urgent
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1show_1unraised
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_show_unraised(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1set_1child_1input_1shapes
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_set_child_input_shapes(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1merge_1child_1input_1shapes
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	gdk_window_merge_child_input_shapes(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1type_1hint
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindowTypeHint result;
	jint _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_type_hint(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1get_1default_1root_1window
(
	JNIEnv* env,
	jclass cls
)
{
	GdkWindow* result;
	jlong _result;

	// call function
	result = gdk_get_default_root_window();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1ensure_1native
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_ensure_native(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkWindow_gdk_1window_1get_1height
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	GdkWindow* self;

	// convert parameter self
	self = (GdkWindow*) _self;

	// call function
	result = gdk_window_get_height(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
