/*
 * java-gnome, a UI library for writing GTK and GNOME programs from Java!
 *
 * Copyright ? 2006-2011 Operational Dynamics Consulting, Pty Ltd and Others
 *
 * The code in this file, and the program it is a part of, is made available
 * to you by its authors as open source software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version
 * 2 ("GPL") as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GPL for more details.
 *
 * You should have received a copy of the GPL along with this program. If not,
 * see http://www.gnu.org/licenses/. The authors of this program may be
 * contacted through http://java-gnome.sourceforge.net/.
 *
 * Linking this library statically or dynamically with other modules is making
 * a combined work based on this library. Thus, the terms and conditions of
 * the GPL cover the whole combination. As a special exception (the
 * "Claspath Exception"), the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your
 * choice, provided that you also meet, for each linked independent module,
 * the terms and conditions of the license of that module. An independent
 * module is a module which is not derived from or based on this library. If
 * you modify this library, you may extend the Classpath Exception to your
 * version of the library, but you are not obligated to do so. If you do not
 * wish to do so, delete this exception statement from your version.
 */

/*
 * THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkColorButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_color_button_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1new_1with_1rgba
(
	JNIEnv* env,
	jclass cls,
	jlong _color
)
{
	GtkWidget* result;
	jlong _result;
	const GdkRGBA* color;

	// convert parameter color
	color = (const GdkRGBA*) _color;

	// call function
	result = gtk_color_button_new_with_rgba(color);

	// cleanup parameter color

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1rgba
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorButton* self;
	const GdkRGBA* color;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter color
	color = (const GdkRGBA*) _color;

	// call function
	gtk_color_button_set_rgba(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _alpha
)
{
	GtkColorButton* self;
	guint16 alpha;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter alpha
	alpha = (guint16) _alpha;

	// call function
	gtk_color_button_set_alpha(self, alpha);

	// cleanup parameter self

	// cleanup parameter alpha
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1rgba
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorButton* self;
	GdkRGBA* color;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter color
	color = (GdkRGBA*) _color;

	// call function
	gtk_color_button_get_rgba(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT jchar JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	GtkColorButton* self;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// call function
	result = gtk_color_button_get_alpha(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1use_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useAlpha
)
{
	GtkColorButton* self;
	gboolean useAlpha;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter useAlpha
	useAlpha = (gboolean) _useAlpha;

	// call function
	gtk_color_button_set_use_alpha(self, useAlpha);

	// cleanup parameter self

	// cleanup parameter useAlpha
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1use_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkColorButton* self;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// call function
	result = gtk_color_button_get_use_alpha(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _title
)
{
	GtkColorButton* self;
	const gchar* title;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter title
	title = (const gchar*) bindings_java_getString(env, _title);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_color_button_set_title(self, title);

	// cleanup parameter self

	// cleanup parameter title
	bindings_java_releaseString(title);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkColorButton* self;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// call function
	result = gtk_color_button_get_title(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) bindings_java_newString(env, result);

	// and finally
	return _result;
}
